
#define _LINUX_ .true.
#define _X_  720
#define _Y_  565
#define _LOFLAG_    -00050
#define _HIFLAG_       1e9

#define _P_       20
      

      program binF
      implicit none

      real pxmin,pxmax
      
      integer i, j, w, k
      
      real pix1(_X_,_Y_)
      real pixb(_X_,_Y_)
      real pixs(_X_,_Y_)
      real nbar(_P_)
      real nnbar(_P_-2)

      integer NTOT,NUSE
      real bar,sig
      
      character*80 INNFILE
      character*80 OUTFILE

      INNFILE = 'polar.fits'
      call readfits_r4(INNFILE,pix1,_X_,_Y_)


      do i=1,_X_
      do j=1,_Y_
         pixb(i,j) = -750.0      
         pixs(i,j) = -750.0      
      enddo
      enddo
      

      do i=1,_X_
      do j=2,_Y_-_P_,_P_
         do w = 1, _P_
            nbar(w) = pix1(i,j+w)
         enddo
         !pxmin = min(nbar(1),nbar(2),nbar(_P_-2),nbar(4),nbar(_P_))
         !pxmax = max(nbar(1),nbar(2),nbar(_P_-2),nbar(4),nbar(_P_))
         pxmin = nbar(1)
         pxmax = nbar(1)
         do w = 1, _P_
            pxmin = min(nbar(w),pxmin)
            pxmax = max(nbar(1),pxmax)
         enddo
         k = 0
         do w = 1, _P_
            if (pix1(i,j+w).ne.pxmin.and.pix1(i,j+w).ne.pxmax) then
               k = k + 1
               nnbar(k) = pix1(i,j+w)
            endif
         enddo
         NTOT=_P_-2
         !!!print *, 'sel --> ', nnbar
         call barsigg(nnbar,NTOT,bar,sig,NUSE)
         !!!print *, 'BAR SIG NT NU ----> = ', bar, sig, NTOT, NUSE
         do w = 1, _P_
            pixb(i,j+w) = bar
            pixs(i,j+w) = sig
         enddo
      enddo
      enddo

      !OUTFILE = 'BINED.fits'
      write(OUTFILE,'(''BINNED.'',i2.2,''.fits'')') _P_
      call writfits_r4(OUTFILE,pixb,_X_,_Y_)
      
      !OUTFILE = 'SIGED.fits'
      write(OUTFILE,'(''SIGED.'',i2.2,''.fits'')') _P_
      call writfits_r4(OUTFILE,pixs,_X_,_Y_)

      continue
      end
      

c--------------------------------------
c
c read a real fits image into an array
c

      subroutine readfits_r4(FILE,pix,NDIMX,NDIMY)
      implicit none

      character*80 FILE
      integer NDIMX,NDIMY
      real    pix(NDIMX,NDIMY)

      character*70 INFO(10)
      common / fitsinfo / INFO 

      integer naxes
      integer laxis(3)

      character*08 field
      character*70 stream 
      
      integer nbyte0
      integer nbyteE
      integer nbyte1
      integer nbyte2
      integer nbper
      integer i,ios, k

      character*2880 buff
      common /sneaky/ buff

      integer ifirst, i1, i2

      integer np1, np2, npt
      integer nextend
      integer nread
      real bscale, bzero
      integer bitpix

      real pixlist(720)
      integer ii, nn, nx, ny

      logical DIAG
      data DIAG /.false./

      character*70 HDR(25)
      common/HDR/HDR


      character*80 FILEU


      FILEU = FILE
      do i = 75,2,-1
         if (FILE(i:i+4).eq.'.fits') FILEU = FILE(1:i+4)
         enddo



      if (DIAG) then
         print*,'enter readfits_r4...'
         print*,'FILE: ',FILE(1:60)
         endif
   
      open(10,file=FILE,status='old',
     .     err=900,recl=2880,form='UNFORMATTED',
     .     access='DIRECT')

      if (DIAG) print*,'...opened'

      naxes = -1
      laxis(1) = 1
      laxis(2) = 1
      laxis(3) = 1 
      nextend = 0

      do i = 1, 10 
         INFO(i) = ' '
         enddo

      do i = 1, 25
         HDR(i) = ' '
         enddo

      i = 0
      nread = 0
 100  continue
      i = i + 1
      read(10,rec=i,iostat=ios) buff
      if (DIAG) print*,'READREC: ',i
      do k = 0, 35, 1
         if (DIAG) write(*,'(i4,1x,i4,1x,a80)') 
     .                   i,k,buff(k*80+1:k*80+80)
         field  = buff(k*80+01:k*80+08)
         stream = buff(k*80+11:k*80+80)
         if (field.eq.'NAXIS   ') read(stream,*) naxes
         if (field.eq.'NAXIS1  ') read(stream,*) laxis(1)
         if (field.eq.'NAXIS2  ') read(stream,*) laxis(2)
         if (field.eq.'NAXIS3  ') read(stream,*) laxis(3)
         if (field.eq.'NEXTEND ') read(stream,*) nextend
         if (field.eq.'BITPIX  ') read(stream,*) bitpix
         if (field.eq.'BSCALE  ') read(stream,*) bscale
         if (field.eq.'BZERO   ') read(stream,*) bzero

         if (field.eq.'EXPTIME ') INFO(1) = stream
         if (field.eq.'FILTNAM1') INFO(2) = stream
         if (field.eq.'FILENAME') INFO(3) = stream
         if (field.eq.'DATE-OBS') INFO(4) = stream
         if (field.eq.'TIME-OBS') INFO(5) = stream
         if (field.eq.'DEC_TARG') INFO(6) = stream
         if (field.eq.'RA_TARG ') INFO(7) = stream
         if (field.eq.'PA_V3   ') INFO(8) = stream
         if (field.eq.'PROPOSID') INFO(9) = stream

         if (field.eq.'CRPIX1  ') HDR(01) = stream
         if (field.eq.'CRPIX2  ') HDR(02) = stream
         if (field.eq.'CRVAL1  ') HDR(03) = stream
         if (field.eq.'CRVAL2  ') HDR(04) = stream
         if (field.eq.'CTYPE1  ') HDR(05) = stream
         if (field.eq.'CTYPE2  ') HDR(06) = stream
         if (field.eq.'CD1_1   ') HDR(07) = stream
         if (field.eq.'CD1_2   ') HDR(08) = stream
         if (field.eq.'CD2_1   ') HDR(09) = stream
         if (field.eq.'CD2_2   ') HDR(10) = stream
         if (field.eq.'ORIENTAT') HDR(11) = stream
         if (field.eq.'PA_APER ') HDR(12) = stream
         if (field.eq.'PA_V3   ') HDR(13) = stream
         if (field.eq.'DATE-OBS') HDR(14) = stream
         if (field.eq.'TIME-OBS') HDR(15) = stream
         if (field.eq.'EXPTIME ') HDR(16) = stream
         if (field.eq.'ROOTNAME') HDR(17) = stream
         if (field.eq.'TARGNAME') HDR(18) = stream
         if (field.eq.'RA_TARG ') HDR(19) = stream
         if (field.eq.'DEC_TARG') HDR(20) = stream
         if (field.eq.'PROPOSID') HDR(21) = stream
         if (field.eq.'FILTER1 ') HDR(22) = stream
         if (field.eq.'FILTER2 ') HDR(23) = stream
         if (field.eq.'VAFACTOR') HDR(24) = stream
         if (field.eq.'CCDGAIN ') HDR(25) = stream

         if (field.eq.'END     ') goto 101
         enddo 
      goto 100
 101  continue

      nread = nread + 1
      if (DIAG) then
         print*,'----------------------------------------'
         print*,'  NREAD: ',nread
         print*,'NEXTEND: ',nextend
         print*,'  NAXIS: ',naxes
         print*,'  LAXIS: ',laxis(1),laxis(2),laxis(3)
         print*,' BITPIX: ',bitpix
         print*,' BSCALE: ',bscale
         print*,'  BZERO: ',bzero
         endif

      ifirst = i+1
      i1 = i
      i2 = i

      nbper  = 4*laxis(1)*laxis(2)
      npt    = laxis(1)*laxis(2)
      nbyte1 = 1 
      nbyte2 = nbper
      i1 = i+1 + nbyte1/2880
      i2 = i+1 + nbyte2/2880

      if (BITPIX.ne.-32) then
         print*,'readfits_r4 prob'
         stop
         endif


      if (laxis(1).ne.NDIMX.or.
     .    laxis(2).lt.NDIMY) then
          print*,'                       '
          print*,'***************        '
          print*,'**  WARNING  **        '
          print*,'***************        '
          print*,'                       '
          print*,'The image:             '
          print*,'                       '
          write(*,'(10x,80a)') FILE
          print*,'                       '
          print*,'has dimensions:        '
          print*,'                       '
          print*,'     laxis1: ',laxis(1)
          print*,'     laxis2: ',laxis(2)
          print*,'                       '
          print*,'This routine is designed to deal with '
          print*,'images of size:  '
          print*,'                 '
          print*,'       ',NDIMX
          print*,'           x     '
          print*,'       ',NDIMY
          print*,'                                           '
          print*,'But it will read the image into as much of '
          print*,'  the array as possible, and will operate  '
          print*,'  on that.                                 '
          print*,'                                           '
          print*,'                                           '
          print*,'***************                            '
          print*,'                                           '
          endif

      nbper  = 4*laxis(1)*laxis(2)
      npt    = laxis(1)*laxis(2)
      nbyte1 = 1
      nbyte2 = nbper
      i1 = i+1 + nbyte1/2880
      i2 = i+1 + nbyte2/2880

      do i = i1, i2, 1
         read(10,rec=i,iostat=ios) buff
         nbyte0 = (i-ifirst)*2880+   1
         nbyteE = (i-ifirst)*2880+2880
         np1 = (nbyte0-nbyte1)/4 + 1
         np2 = (nbyteE-nbyte1)/4 + 1
         if (_LINUX_) call buffflip_r4r
         call buff2pix_r4(pixlist,001,720)
         do ii = 001, 720
            nn = np1 + (ii-1)
            ny = 1 + nn/laxis(1)
            nx = nn-(ny-1)*laxis(1)
            if (nx.ge.000.and.nx.le.NDIMX.and.
     .          ny.ge.000.and.ny.le.NDIMY) then
                pix(nx,ny) = pixlist(ii)
                endif
            enddo
         if (ny.gt.NDIMY) goto 899
         enddo

 899  continue
      close(10)
      return

 900  continue
      print*,'READFITS_R4 ERROR',FILEU
      stop

      end



c-------------------------------------
c
c flip the buffer for readfits_r4
c
      subroutine buffflip_r4r
      implicit none
      character buff(2880)
      common /sneaky/ buff
      character temp(4)
      integer i

      do i = 0, 2876,4
         temp(1) = buff(i+1)
         temp(2) = buff(i+2)
         temp(3) = buff(i+3)
         temp(4) = buff(i+4)
         buff(i+1) = temp(4)
         buff(i+2) = temp(3)
         buff(i+3) = temp(2)
         buff(i+4) = temp(1)
         enddo

      return
      end



c--------------------------
c
c copy over the buffer for readfits_r4
c
      subroutine buff2pix_r4(pix,n1,nt)
      implicit none 
      real pix(*)
      integer n1,nt
 
      real pbuff(720)
      common /sneaky/pbuff
      integer i
      integer npu

      do i = 1, 720
         npu = n1+i-1
         if (npu.ge.1.and.npu.le.nt) pix(npu) = pbuff(i)
         enddo
  
      return
      end


c--------------------------------------------------
c
c output a real*4 image to a fits file
c
c
      subroutine writfits_r4(FILE,pix,PXDIMX,PXDIMY)
      implicit none

      character*80 FILE
      integer PXDIMX,PXDIMY
      real    pix(PXDIMX,PXDIMY)

      integer nbyte0
      integer nbyteE
      integer nbyte1
      integer nbyte2
      integer nbper
      integer i,ios

      character*2880 buff
      common /sneaky/ buff

      integer ifirst, i1, i2

      integer np1, np2, npt

      character*70 HDR(25)
      common/HDR/HDR
      character*80 FILEU

      FILEU = FILE
      do i = 75,2,-1
         if (FILE(i:i+4).eq.'.fits') FILEU = FILE(1:i+4)
         enddo

      write(*,'(''writfits_r4:  '',i4,''x'',i4,1x,80a)') 
     .            PXDIMX,PXDIMY,FILEU

      open(10,file=FILEU,status='unknown',
     .     err=900,recl=2880,form='UNFORMATTED',
     .     access='DIRECT')


      i = 1
      write(buff( 0*80+1: 1*80),'(''SIMPLE  = T      '')')
      write(buff( 1*80+1: 2*80),'(''BITPIX  = -32    '')')
      write(buff( 2*80+1: 3*80),'(''NAXIS   ='',i12)') 2
      write(buff( 3*80+1: 4*80),'(''NAXIS1  ='',i12)') PXDIMX
      write(buff( 4*80+1: 5*80),'(''NAXIS2  ='',i12)') PXDIMY
      write(buff( 5*80+1: 6*80),'(''DATATYPE='',9a)') 
     .                          ' ''REAL*4'''
      write(buff( 6*80+1: 7*80),'(''DATE    ='',11a)') 
     .                          ' ''00/00/00'''
      write(buff( 7*80+1: 8*80),'(''BSCALE  ='',i12)') 00001
      write(buff( 8*80+1: 9*80),'(''BZERO   ='',i12)') 00000
      write(buff(09*80+1:10*80),'(''CRPIX1  ='',a20)') HDR(01)
      write(buff(10*80+1:11*80),'(''CRPIX2  ='',a20)') HDR(02)
      write(buff(11*80+1:12*80),'(''CRVAL1  ='',a20)') HDR(03)
      write(buff(12*80+1:13*80),'(''CRVAL2  ='',a20)') HDR(04)
      write(buff(13*80+1:14*80),'(''CTYPE1  ='',a20)') HDR(05)
      write(buff(14*80+1:15*80),'(''CTYPE2  ='',a20)') HDR(06)
      write(buff(15*80+1:16*80),'(''CD1_1   ='',a20)') HDR(07)
      write(buff(16*80+1:17*80),'(''CD1_2   ='',a20)') HDR(08)
      write(buff(17*80+1:18*80),'(''CD2_1   ='',a20)') HDR(09)
      write(buff(18*80+1:19*80),'(''CD2_2   ='',a20)') HDR(10)
      write(buff(19*80+1:20*80),'(''ORIENTAT='',a20)') HDR(11)
      write(buff(20*80+1:21*80),'(''PA_APER ='',a20)') HDR(12)
      write(buff(21*80+1:22*80),'(''PA_V3   ='',a20)') HDR(13)
      write(buff(22*80+1:23*80),'(''DATE-OBS='',a20)') HDR(14)
      write(buff(23*80+1:24*80),'(''TIME-OBS='',a20)') HDR(15)
      write(buff(24*80+1:25*80),'(''EXPTIME ='',a20)') HDR(16)
      write(buff(25*80+1:26*80),'(''ROOTNAME='',a20)') HDR(17)
      write(buff(26*80+1:27*80),'(''TARGNAME='',a20)') HDR(18)
      write(buff(27*80+1:28*80),'(''RA_TARG ='',a20)') HDR(19)
      write(buff(28*80+1:29*80),'(''DEC_TARG='',a20)') HDR(20)
      write(buff(29*80+1:30*80),'(''PROPOSID='',a20)') HDR(21)
      write(buff(30*80+1:31*80),'(''FILTER1 ='',a20)') HDR(22)
      write(buff(31*80+1:32*80),'(''FILTER2 ='',a20)') HDR(23)
      write(buff(33*80+1:34*80),'(''VAFACTOR='',a20)') HDR(24)
      write(buff(32*80+1:33*80),'(''CCDGAIN ='',a20)') HDR(25)
      write(buff(34*80+1:35*80),'(''COMMENT  '')')
      write(buff(35*80+1:36*80),'(''END      '')')

      write(10,rec=i,iostat=ios) buff


      ifirst = i+1
      i1 = i
      i2 = i

      nbper  = 4*PXDIMX*PXDIMY
      npt    =   PXDIMX*PXDIMY
      nbyte1 = 1 
      nbyte2 = nbper
      i1 = i+1 + nbyte1/2880
      i2 = i+1 + nbyte2/2880

      do i = i1, i2, 1
         nbyte0 = (i-ifirst)*2880+   1
         nbyteE = (i-ifirst)*2880+2880
         np1 = (nbyte0-nbyte1)/4 + 1
         np2 = (nbyteE-nbyte1)/4 + 1
         call pix2buff(pix,np1,npt)
         if (_LINUX_) call buffflip_r4
         write(10,rec=i,iostat=ios) buff
         enddo 

      close(10)

      return

 900  continue
      print*,'WRITFITS.f ERROR'
      stop

      end


c-----------------------------------
c
c copy the array to the buffer
c
      subroutine pix2buff(pix,n1,nt)
      implicit none 
      real pix(*)
      integer n1,nt
 
      real pbuff(720)
      common /sneaky/pbuff
      integer i
      integer npu

      do i = 1, 720
         npu = n1+i-1
         if (npu.ge.1.and.npu.le.nt) pbuff(i) = pix(npu)
         enddo
 
      return
      end

c-----------------------------------
c
c flip the buffer (for linux)
c
      subroutine buffflip_r4
      implicit none
      character buff(2880)
      common /sneaky/ buff
      character temp(4)
      integer i

      do i = 0, 2876,4
         temp(1) = buff(i+1)
         temp(2) = buff(i+2)
         temp(3) = buff(i+3)
         temp(4) = buff(i+4)
         buff(i+1) = temp(4)
         buff(i+2) = temp(3)
         buff(i+3) = temp(2)
         buff(i+4) = temp(1)
         enddo

      return
      end


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c-----------------------------------------------------
c
c barsig for small number statistics... N<=6
c
c
      subroutine barsig_sns(xlist,NTOTT,bar,sig,NUSE)
      implicit none
 
      integer NTOTT
      real  xlist(_P_)
      real  bar
      real  sig
      integer NUSE
 
      integer NTOT
      integer n
      real bar1, sig1
      real bar2, sig2
      real bar3, sig3
      real    slist(5)
      character clist(5)
 
      NTOT = NTOTT
 

      if (NTOT.eq.0) then
         bar = 0.
         sig = 0.
         NUSE = 0
         return
         endif
 
      do n = 1, NTOT
         slist(n) = xlist(n)
         enddo
 
      NTOT = NTOTT
 777  continue
      call dbubble(slist,NTOT)
 
      if (NTOT.eq.5) then
         if (slist(3).gt.35000.and.
     .       slist(2).lt.01000.and.
     .       slist(1).lt.01000) then
               NTOT = 2
               goto 777
               endif
         bar1 = (slist(1)+slist(2)+slist(3)+slist(4))/4
         sig1 = (slist(4)-slist(1))/2
         bar2 = (slist(2)+slist(3)+slist(4)+slist(5))/4
         sig2 = (slist(5)-slist(2))/2
         bar3 = (slist(1)+slist(2)+slist(3))/3
         sig3 = (slist(3)-slist(1))*1.5
         bar = bar1
         sig = sig1
         if (sig2.lt.sig1) then
            bar = bar2
            sig = sig2
            endif
         if (sig3.lt.sig1) then
            bar = bar3
            sig = sig3
            endif
         if (sig.lt.0.10*abs(bar)) sig = 0.10*abs(bar)
         if (slist(5).gt.bar+3*sig) then
            NTOT = 4
            goto 777
            endif
         if (slist(1).lt.bar-3*sig) then
            NTOT = 4
            slist(1) = slist(2)
            slist(2) = slist(3)
            slist(3) = slist(4)
            slist(4) = slist(5)
            goto 777
            endif
         bar = (slist(1)+slist(2)+slist(3)+
     .          slist(4)+slist(5))/5
         sig = (abs(slist(1)-bar)
     .         +abs(slist(2)-bar)
     .         +abs(slist(3)-bar)
     .         +abs(slist(4)-bar)
     .         +abs(slist(5)-bar))/4
         NUSE = 5
         goto 666
         endif
      if (NTOT.eq.4) then
         if (slist(3).gt.35000.and.
     .       slist(2).lt.01000.and.
     .       slist(1).lt.01000) then
               NTOT = 2
               goto 777
               endif
         bar1 = (slist(1)+slist(2)+slist(3))/3
         sig1 = (slist(3)-slist(1))
         bar2 = (slist(2)+slist(3)+slist(4))/3
         sig2 = (slist(4)-slist(2))
         bar3 = (slist(1)+slist(2))/2
         sig3 = (slist(2)-slist(1))*3
         bar = bar1
         sig = sig1
         if (sig2.lt.sig1) then
            bar = bar2
            sig = sig2
            endif
         if (sig3.lt.sig1) then
            bar = bar3
            sig = sig3
            endif
         if (sig.lt.0.10*abs(bar)) sig = 0.10*abs(bar)
         if (slist(4).gt.bar+3*sig) then
            NTOT = 3
            goto 777
            endif
         if (slist(1).lt.bar-3*sig) then
            NTOT = 3
            slist(1) = slist(2)
            slist(2) = slist(3)
            slist(3) = slist(4)
            goto 777
            endif
         bar = (slist(1)+slist(2)+slist(3)+slist(4))/4
         sig = (abs(slist(1)-bar)
     .         +abs(slist(2)-bar)
     .         +abs(slist(3)-bar)
     .         +abs(slist(4)-bar))/3
         NUSE = 4
         goto 666
         endif
      if (NTOT.eq.3) then
         bar1 = (slist(1)+slist(2))/2
         sig1 = (slist(2)-slist(1))
         bar2 = (slist(2)+slist(3))/2
         sig2 = (slist(3)-slist(2))
         bar = bar1
         sig = sig1
         if (sig2.lt.sig1) then
            bar = bar2
            sig = sig2
            endif
         if (sig.lt.0.10*abs(bar)) sig = 0.10*abs(bar)
         if (slist(3).gt.bar+3*sig) then
            NTOT = 2
            goto 777
            endif
         if (slist(1).lt.bar-3*sig) then
            NTOT = 2
            slist(1) = slist(2)
            slist(2) = slist(3)
            goto 777
            endif
         bar = (slist(1)+slist(2)+slist(3))/3
         sig = (abs(slist(1)-bar)
     .         +abs(slist(2)-bar)
     .         +abs(slist(3)-bar))/2
         NUSE = 3
         goto 666
         endif
      if (NTOT.eq.2) then
         bar = slist(1)
         sig = 4
         if (sig.lt.0.10*abs(bar)) sig = 0.10*abs(bar)
         if (slist(2).gt.bar+5*sig) then
            NUSE = 1
            bar = slist(1)
            sig = 59.9
            goto 666
            endif
         if (abs(slist(2)).lt.20.and.slist(1).lt.-50) then
            NUSE = 1
            bar = slist(2)
            sig = 59.9
            goto 666
            endif
         bar = (slist(1)+slist(2))/2
         sig = (slist(2)-slist(1))/2
         NUSE = 2
         goto 666
         endif
      if (NTOT.eq.1) then
         bar = slist(1)
         sig = 59.9
         NUSE = 1
         goto 666
         endif
 
      print*,' '
      print*,'---> STOP...'
      print*,' '
      print*,'---> SHOULD NOT BE HERE.'
      print*,' '
 
 666  continue
      return
 
      end
 
c--------------------------------------------
c
c bubble sort a real*8 into ascending order
c
      subroutine dbubble(r1,NTOT)
      implicit none
      real r1(1)
      integer NTOT
      integer n
      real temp
      logical change
 777  continue
      change = .false.
      do n = 1, NTOT-1
         if (r1(n).gt.r1(n+1)) then
            temp = r1(n)
            r1(n) = r1(n+1)
            r1(n+1) = temp
            change = .true.
            endif
         enddo
      if (change) goto 777
      end
 
 
c---------------------------------------------------
c
c this is the routine that takes in several estimates
c of the pixel value and computes *some* kind of
c sigma clipped average for them.
c
      subroutine barsigg(xlist,NTOT,bar,sig,NUSE)
      implicit none
 
      integer NTOT
      real xlist(NTOT)
      real bar
      real sig
      integer NUSE
 
      integer n
      real*8    bsum, ssum
      integer nsum
      integer NIT
 
      NUSE = NTOT
 
      bar = 0.e0
      sig = 9e9
      do NIT = 01, 50
         bsum = 0.
         ssum = 0.
         nsum = 0.
         do n = 1, NTOT
            if (abs(xlist(n)-bar).le.2.00*sig) then
               bsum = bsum + xlist(n)
               ssum = ssum + abs(xlist(n)-bar)
               nsum = nsum + 1
               endif
            enddo
         if (nsum.gt.0) bar = bsum/ nsum
         if (nsum.gt.1) sig = ssum/(nsum-1)
         enddo
      NUSE = nsum
      if (nsum.le.1) sig = 0.999
 
      return
      end
 
 
 
